<?php

/**
 * @file
 * Handles exporting of URL aliases.
 */

/**
 * Build an array of operations for exporting each alias.
 */
function mover_export_aliases_operations($callback) {
  $result = db_query("SELECT pid FROM {url_alias} ORDER BY pid");
  while ($u = db_fetch_object($result)) {
    $operations[] = array($callback, array($u->pid));
  }
  $operations[] = array('mover_export_make_tarball_process', array('aliases'));
  return $operations;
}

/**
 * Batch processing callback for exporting each alias.
 */
function mover_export_aliases_process($pid, &$context) {
  $alias = db_fetch_object(db_query("SELECT * FROM {url_alias} WHERE pid=%d", $pid));
  if ($alias->pid) {

    // Let other modules do special fixing up.
    // The function signature is: hook_mover_export_alter(&$alias, $type)
    // Where $method is 'export'
    drupal_alter('mover_export', $alias, 'alias');
    $alias = mover_remove_recursion($alias);
    $data = mover_object_encode($alias);

    // Write the exported file
    $directory = variable_get('mover_export_directory', '');
    $subdirectory = mover_get_directory_for_file($directory, 'aliases', $context);
    $filepath = $subdirectory .'/'. $alias->pid .'.txt';
    file_put_contents($filepath, $data);

    $context['message'] = check_plain($alias->source);
    $context['results'][] = check_plain($alias->source);
  }
  else {
    $message = t('Unable to load alias @pid', array('@pid' => $pid));
    drupal_set_message($message);
    $context['message'] = check_plain($message);
    $context['results'][] = $pid;
  }
}
