<?php

/**
 * @file
 * Handles importing of URL Aliases.
 */

/**
 * Creates or returns a new redirect based on raw redirect data.
 */
function mover_import_aliases_process_import($data) {
  $old_src = $data->src;
  if (preg_match('/taxonomy\/term\/([0-9]+)/', $old_src, $match)) {
    $old_id = $match[1];
    $new_id = mover_import_get_new_id('term', $old_id);
    if ($new_id) {
      $new_src = 'taxonomy/term/'. $new_id;
    }
  }
  elseif (preg_match('/node\/([0-9]+)/', $old_src, $match)) {
    $old_id = $match[1];
    $new_id = mover_import_get_new_id('node', $old_id);
    if ($new_id) {
      $new_src = 'node/'. $new_id;
    }
  }
  elseif (preg_match('/user\/([0-9]+)/', $old_src, $match)) {
    $old_id = $match[1];
    $new_id = mover_import_get_new_id('user', $old_id);
    if ($new_id) {
      $new_src = 'user/'. $new_id;
    }
  }
  else {
    $new_src = $old_src;
  }

  if (isset($new_src)) {
    mover_import_add_path_redirect($data->dst, $new_src);
  }
  else {
    drupal_set_message(t('Unable to find new path for alias %alias which pointed to %old-src',
      array('%alias' => $data->dst, '%old-src' => $old_src)), 'error');
  }
}
